Part Skripten

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Part scripting and the translation is 86% complete.
Other languages:
Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎русский

Einführung

Die im Modul Part verwendete Hauptdatenstruktur ist der Datentyp BRep von OpenCascade. Fast alle Inhalte und Objekttypen des Part Moduls sind per Python Skripten verfügbar. Dazu gehören geometrische Primitive wie Linie und Kreis (oder Bogen) und die gesamte Palette der TopoFormen, wie Knoten, Kanten, Drähte, Flächen, Festkörper und Verbünde. Für jedes dieser Objekte gibt es mehrere Erstellungsmethoden, und für einige von ihnen, insbesondere die TopoFormen, sind auch fortgeschrittene Operationen wie Bool'sche Vereinigung/Differenz/Überschneidung verfügbar. Entdecke den Inhalt des Part Moduls, wie auf der Seite FreeCAD Grundlagen SKripten beschrieben, um mehr zu erfahren.

Das grundlegendste Objekt, das erstellt werden kann, ist ein Part Formelement, das eine einfache Daten-EigenschaftPlatzierungs Eigenschaft und Grundeigenschaften hat, um seine Farbe und sein Aussehen zu definieren.

Ein weiteres einfaches Objekt, das in geometrischen 2D Objekten verwendet wird, ist Part Part2DObjekt, das die Basis von Skizzierer SkizzeObjekt ist. (Skizzierer), und die meisten Entwurfselemente.

Siehe auch

Testskript

Teste die Erstellung von Part Grundelementen mit einem Skript. introduced in version 0.19

import parttests.part_test_objects as pto
pto.create_test_file("example_file")

Dieses Skript befindet sich im Installationsverzeichnis des Programms und kann untersucht werden, um zu sehen, wie die Basisgrundelemente aufgebaut sind.

$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py

Beispiele

Zum erstellen eines Linienelements schalte um zur Python Konsole und gib ein:

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Lass uns das obige Python Beispiel Schritt für Schritt betrachten:

import Part,PartGui
doc=App.newDocument()

lädt die Part Modul und erstellt ein neues Dokument

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line ist eigentlich eine Linienabschnitt, folglich der Anfangs- und Endpunkt.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

Dadurch wird dem Dokument ein Part Objekttyp hinzugefügt und weist die Formdarstellung des Liniensegments der 'Form' Eigenschaft des hinzugefügten Objekts zu. Es ist wichtig, hier zu verstehen, dass wir ein geometrisches Grundelement (das Part.LineSegment) verwendet haben, um daraus eine TopoForm zu erstellen (die toShape() Methode). Nur Formen können dem Dokument hinzugefügt werden. In FreeCAD werden Geometrie Grundelemente als "Baustrukturen" für Formen verwendet.

doc.recompute()

Aktualisiert das Dokument. Damit auch die visuelle Darstellung des neuen Part Objekts.

Beachte, dass ein Liniensegment durch Angabe der Anfangs-und Endpunkt direkt im Konstruktor erstellt werden kann, z.B. Part.LineSegment (Punkt1, Punkt2), oder wir können eine Standardlinie erstellen und seine Eigenschaften anschießend festlegen, wie wir es hier gemacht haben.

Eine Linie kann erstellt werden auch mit:

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateLine(pt1, pt2, objName):
    obj = DOC.addObject("Part::Line", objName)
    obj.X1 = pt1[0]
    obj.Y1 = pt1[1]
    obj.Z1 = pt1[2]

    obj.X2 = pt2[0]
    obj.Y2 = pt2[1]
    obj.Z2 = pt2[2]

    DOC.recompute()
    return obj

line = mycreateLine((0,0,0), (0,10,0), "LineName")

Ein Kreis kann in ähnlicher Weise erstellt werden:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

oder mit:

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateCircle(rad, objName):
    obj = DOC.addObject("Part::Circle", objName)
    obj.Radius = rad

    DOC.recompute()
    return obj

circle = mycreateCircle(5.0, "CircleName")

or create a circle defined by it's center, axis and radius using:

import Part
doc = App.activeDocument()
center = App.Vector(1,2,3)
axis = App.Vector(1,1,1)
radius = 10
c=Part.Circle(center,axis,radius)
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

or create a circle defined by three points using:

import Part
doc = App.activeDocument()
p1 = App.Vector(10,0,0)
p2 = App.Vector(0,10,0)
p3 = App.Vector(0,0,10)
c = Part.Circle(p1,p2,p3)
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Bemerke wieder, wir verwendeten den Kreis (Geometrie Grundelement), um eine Form daraus zu erstellen. Wir können natürlich noch immer auf unsere Konstruktionsgeometrie später zugreifen, und zwar so:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Hier nehmen wir die Form unseres Objekts f, dann nehmen wir die Liste der Kanten. In diesem Fall wird es nur eine geben, weil wir die ganze Form aus einem einzelnen Kreis machten, also nehmen wir nur das erste Element der Kantenliste, und wir nehmen seinen Verlauf. Jede Kante hat einen Verlauf, welches das Geometrie Grundelement ist, worauf der Verlauf basiert ist.

Gehe auf die Seite Topologisches Datenskripting, wenn du mehr wissen möchtest.